'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : [select VIEW...EDITOR OPTIONS]                    *
'*  Notice  : Copyright (c) 2010 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 24.12.2010                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
Device = 16F628A
Xtal = 4
;Config BOREN_OFF, CP_OFF, DATA_CP_OFF, PWRTE_ON, WDT_OFF, LVP_OFF, MCLRE_ON, INTRC_OSC_NOCLKOUT
@CONFIG_REQ
    @__CONFIG 3F30h
    
    Create_Coff = 1
    All_Digital = 1
    
     ;        T1CON
     
     Symbol TMR1ON = T1CON.0     ' Timer1 ON
     Symbol TMR1CS = T1CON.1     ' Timer1 Clock Source Select
     Symbol T1SYNC = T1CON.2     ' Timer1 External Clock Input Synchronization Control
     Symbol T1OSCEN = T1CON.3    ' Timer1 Oscillator Enable Control
     Symbol T1CKPS0 = T1CON.4    ' Timer1 Input Clock Prescale Select bits
     Symbol T1CKPS1 = T1CON.5    ' Timer1 Input Clock Prescale Select bits


      ;     INTCON
      Symbol RBIF = INTCON.0 ' RB Port Interrupt Flag
      Symbol INTF = INTCON.1 ' RB0 External Interrupt Flag
      Symbol T0IF = INTCON.2 ' TMR0 Overflow Interrupt Flag
      Symbol RBIE = INTCON.3 ' RB Port Change Interrupt Enable
      Symbol INTE = INTCON.4 ' RB0 External Interrupt Enable
      Symbol T0IE = INTCON.5 ' TMR0 Overflow Interrupt Enable
      Symbol PEIE = INTCON.6 ' Peripheral Interrupt Enable
      Symbol GIE = INTCON.7  ' Global Interrupt Enable
         
      ;      PIE1
      Symbol TMR1IE = PIE1.0 ' TMR1 Overflow Interrupt Enable
      Symbol TMR2IE = PIE1.1 ' TMR2 to PR2 Match Interrupt Enable
      Symbol CCP1IE = PIE1.2 ' CCP1 Interrupt Enable
      Symbol TXIE = PIE1.4   ' USART Transmit Interrupt Enable
      Symbol RCIE = PIE1.5   ' USART Receive Interrupt Enable
      Symbol CMIE = PIE1.6   ' Comparator Interrupt Enable
      Symbol EEIE = PIE1.7   ' EE Write Complete Interrupt Enable

      Symbol TMR1IF = PIR1.0 ' TMR1 Overflow Interrupt Flag bit
      Symbol TMR2IF = PIR1.1 ' TMR2 to PR2 Match Interrupt Flag
      Symbol CCP1F = PIR1.2  ' CCP1 Interrupt Flag
      Symbol TXIF = PIR1.4   ' USART Transmit Interrupt Flag
      Symbol RCIF = PIR1.5   ' USART Receive Interrupt Flag
      Symbol CMIF = PIR1.6   ' Comparator Interrupt Flag
      Symbol EEIF = PIR1.7   ' EEPROM Write Operation Interrupt Flag

       Dim TIMER1 As TMR1L.Word     ' Combine TMR1L, and TMR1H into WORD variable TIMER1
       TIMER1 = 12345               ' Load TMR1 with value 12345
       Dim pausa As Word
       Dim flag As Bit
    On_Hardware_Interrupt GoTo ISR
    
    GoTo init
ISR:

 Inc pausa
 
 TIMER1 = 3036
 TMR1IF = 0     ;     1
Context Restore

init:
 Clear
 TRISA = %00001100 
 PORTA = 0
 TRISB = 0
 PORTB = 0
 
; tmr1on = 1  ;  1
 TMR1CS = 0  ;    Fosc/4
 T1OSCEN = 1 ;   
 T1CKPS0 = 1 ;  ---- 
 T1CKPS1 = 1 ;  1 : 8
 TMR1IE = 1  ;    1
 PEIE = 1    ;   
 GIE = 1     ;   
 
 pausa = 0
 flag = 0
  ;   TIMER1 = 3036 ;    500 
  ;   tmr1on = 1    ;  
 
 
main:
 
 
 If PORTA.2 = 1 And PORTA.3 = 0 And flag = 0 Then
     flag = 1
     PORTB.0 = 1
     TIMER1 = 3036 ;    500 
     TMR1ON = 1    ;  
 EndIf


main1:

 If PORTA.2 = 1 And PORTA.3 = 0 And flag = 1 Then
    ; portb.0 = 1
 Else
     flag = 0
         TMR1ON = 0
         pausa = 0
         PORTB.0 = 0
         GoTo main
 
 EndIf


       If pausa >= 20 Then  ;     10  ( 5 .  600)
         TMR1ON = 0
         pausa = 0
         PORTB.0 = 0
         GoTo main
       EndIf   
 
       nop
       nop
GoTo main1
End    
